// LeoCadPartList.cpp : Defines the entry point for the console application.
//


#include "stdafx.h"
#include "LeoCadPartList.h"


int main(int argc, char* argv[])
{
	
	int i,j,k;
	int result;
	long NbrPieces;
	char MainFile[MAX_PATH];
	char BomFile[MAX_PATH];
	int stlength;

	int Part_Type_Num;
	char PieceVer;
	int PieceVerOffset;

	T_Piece Piece[MAX_PART_TYPE];

	char CurPartNum [PART_NUM_LENGTH];
	char CurPartName [PART_NAME_LENGTH];

	long FilePtr;
	FILE *LcdFile;
	FILE *BomList;

	printf("\nLeoCad Part List\n----------------\n\n");


	if(argc != 2) {
		printf ("Syntax: LeoCadPartList Lcd_file.lcd\n");
		printf("Press <Enter> to quit");
		getchar();
		return 1;
	}
	
	
	strcpy(MainFile, argv[1]);

	if(stricmp (MainFile + strlen(MainFile) - 4, ".lcd") != 0)
	{
		printf("File %s\nshould have .lcd extension\n", MainFile);
		printf("Press <Enter> to quit");
		getchar();
		return 3;
	}


	strcpy(BomFile, MainFile);
	strcpy(BomFile + strlen(MainFile) - 4, ".txt");

	BomList = fopen (BomFile, "wt");

	if(BomList == NULL)
	{
		printf("Can't create file\n%s\n", BomFile);
		printf("Press <Enter> to quit");
		getchar();
		return 4;
	}


	LcdFile = fopen (MainFile, "rb");

	if(LcdFile == NULL)
	{
		printf("File %s\nwas not found\n", MainFile);
		printf("Press <Enter> to quit");
		getchar();
		return 2;
	}
	
	printf("Inventory of:\n%s\n", MainFile);

	FilePtr = NUM_PIECES;
	fseek (LcdFile, FilePtr, SEEK_SET);

	fread (&NbrPieces, sizeof(NbrPieces),1,LcdFile);
	fprintf(BomList, "Number of pieces: %li\n", NbrPieces);

	PieceVer = fgetc(LcdFile);
	printf("Pieces save version: %i\n", PieceVer);

	PieceVerOffset = (PieceVer == 8) ? -1 : 0;

	FilePtr = FIRST_PART + PieceVerOffset;


	
	Part_Type_Num = 0;
	Piece[0].PartName[0] = 0x7f;
	Piece[0].PartName[1] = 0;

	for (j=0; j<NbrPieces; j++)
	{
		fseek (LcdFile, FilePtr, SEEK_SET);
		fread (CurPartNum, PART_NUM_LENGTH,1,LcdFile);

		//Horrible kludge!!!)
		for(i=0; i<PART_NUM_LENGTH; i++)
		{
			if(i>0 && CurPartNum[i]==0) break;
			if(CurPartNum[0] <'0' || (CurPartNum[0] >'9' && CurPartNum[0] <'A') || (CurPartNum[0] >'Z' && CurPartNum[0] <'a') || CurPartNum[0] >'z')
			{
				FilePtr +=19;
				fseek (LcdFile, FilePtr, SEEK_SET);
				fread (CurPartNum, PART_NUM_LENGTH,1,LcdFile);
				break;
			}
		}

		for(i=0; i<PART_NUM_LENGTH; i++)
		{
			if(i>0 && CurPartNum[i]==0) break;
			if(CurPartNum[0] <'0' || (CurPartNum[0] >'9' && CurPartNum[0] <'A') || (CurPartNum[0] >'Z' && CurPartNum[0] <'a') || CurPartNum[0] >'z')
			{
				FilePtr +=19;
				fseek (LcdFile, FilePtr, SEEK_SET);
				fread (CurPartNum, PART_NUM_LENGTH,1,LcdFile);
				break;
			}
		}

		for(i=0; i<PART_NUM_LENGTH; i++)
		{
			if(i>0 && CurPartNum[i]==0) break;
			if(CurPartNum[0] <'-' || (CurPartNum[0] >'9' && CurPartNum[0] <'A') || (CurPartNum[0] >'Z' && CurPartNum[0] <'_') || CurPartNum[0] >'z')
			{
				FilePtr +=19;
				fseek (LcdFile, FilePtr, SEEK_SET);
				fread (CurPartNum, PART_NUM_LENGTH,1,LcdFile);
				break;
			}
		}
		fseek (LcdFile, FilePtr + NUM_TO_NAME - 1, SEEK_SET);
		
		stlength = fgetc (LcdFile);
//		printf("%s %d ",CurPartNum, stlength);

		for (i=0; i<stlength; i++)
			CurPartName[i] = fgetc(LcdFile);
		CurPartName[stlength] = 0;

//		printf("%lx ", FilePtr);
	
		FilePtr += NUM_TO_NAME + NAME_TO_NUM + stlength + PieceVerOffset;

//		printf("%lx %s\n", FilePtr, CurPartName);

		for (i=stlength-1; i>=0; i--)
		{
			if (CurPartName[i] == '#') break;
		}
		CurPartName[i-1] = 0;
		for (i=0; i<=NbrPieces; i++)
		{
			if((result = stricmp(CurPartName, Piece[i].PartName))==0)
			{
				Piece[i].PieceNbr++;
				break;
			}
			if(result < 0)
			{
				
				for (k=Part_Type_Num; k>=i; k--)
					Piece[k+1] = Piece[k];
				Piece[i].PieceNbr = 1;
				strcpy (Piece[i].PartNum, CurPartNum);
				strcpy (Piece[i].PartName, CurPartName);
				Part_Type_Num++;
				break;
			}
		}
	}

	fprintf(BomList, "Number of part types: %i\n", Part_Type_Num);
	fprintf(BomList, "\n   #| Part#  | Part name");
	fprintf(BomList, "\n----+--------+--------------------------------");
	for (i=0; i<Part_Type_Num; i++)
	{
		fprintf(BomList, "\n%4i|%8s|%s", Piece[i].PieceNbr, Piece[i].PartNum, Piece[i].PartName);
	}

	fprintf(BomList, "\n");
	fclose (LcdFile);
	fclose (BomList);
	printf("Part list file created:\n%s\n\n", BomFile);
	printf("Press <Enter> to quit");
	getchar();
	return 0;
}

